Name:           libcds
Version:        2.3.3
Release:        1%{?dist}
Summary:        A C++ library of Concurrent Data Structures

License:        Boost Software License 1.0
URL:            https://github.com/khizmax/libcds
Source0:        https://github.com/khizmax/libcds/archive/v%{version}.tar.gz#/%{name}-%{version}.tar.gz

Patch0:         LibSuffix.patch

%if 0%{?rhel}
BuildRequires:  gcc-toolset-9
%else
BuildRequires:  gcc-c++
%endif
BuildRequires:  cmake3

%description
The Concurrent Data Structures (CDS) library is a collection of concurrent
containers that don't require external (manual) synchronization for shared
access, and safe memory reclamation (SMR) algorithms like Hazard Pointer
and user-space RCU that is used as an epoch-based SMR.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
This package contains the header file for using %{name}.

%package        static
Summary:        Header only development files for %{name}
Requires:       %{name}-devel%{?_isa} = %{version}-%{release}

%description    static
This package contains the files for using %{name} as a header only library.

%prep
%autosetup

%build
%if 0%{?rhel}
scl enable gcc-toolset-9 - << \SCLEOF
set -e
%endif
mkdir _build
cd _build
%cmake3 -DCMAKE_BUILD_TYPE=RelWithDebInfo ..
make all
%if 0%{?rhel}
SCLEOF
%endif

%install
cd _build
make install DESTDIR=%{buildroot}

%files
%{_libdir}/libcds.so.*

%files devel
%{_includedir}/cds/
%{_libdir}/libcds.so
%{_libdir}/cmake/LibCDS/

%files static
%{_libdir}/libcds-s.a
